
// Testar se funciona corretamente o empilhamento de par�metros
// passados por valor ou por refer�ncia.


%{
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include "compilador.h"
#include "ts/ts.h"
#include "stack/stack.h"

int num_vars;
int num_param;
ts_t *ts;
int nivel_lexico;
int desloc;
int destino_nivel;
int destino_desloc;
simb_t *l_elem;
int rot_id;
custom_stack_t *rot;
custom_stack_t *proc;

int val_ou_ref;
int atr_indireto;

%}

%token PROGRAM ABRE_PARENTESES FECHA_PARENTESES
%token VIRGULA PONTO_E_VIRGULA DOIS_PONTOS PONTO
%token T_BEGIN T_END VAR IDENT ATRIBUICAO
%token LABEL TYPE ARRAY PROCEDURE FUNCTION
%token GOTO IF THEN ELSE WHILE DO OR DIV
%token AND NOT IGUAL DIFERENTE MENOR_IGUAL
%token MAIOR_IGUAL MENOR MAIOR MAIS MENOS
%token ASTERISCO NUMERO READ WRITE

%nonassoc LOWER_THAN_ELSE
%nonassoc ELSE

%%

// REGRA 1
programa    :{
             geraCodigo (NULL, "INPP");
             }
             PROGRAM IDENT
             ABRE_PARENTESES lista_idents FECHA_PARENTESES PONTO_E_VIRGULA
             bloco PONTO 
             {
               geraCodigo (NULL, "PARA");
             }
;

// REGRA 2
bloco       :
	      parte_declara_rotulos
         parte_declara_vars

         {
            char r_main[4];
            sprintf(r_main, "R%02d", rot_id);
            empilha(r_main, rot);
            rot_id += 1;
            char buffer[50];
            strcpy(buffer,"DSVS ");
            strcat(buffer,r_main);
            geraCodigo(NULL,buffer);
         }
	      parte_declara_subrotinas
         {
            char r_main[4];
            desempilha(r_main,rot);
            geraCodigo(r_main,"NADA");
         }

         comando_composto {
            char buffer[50];
            sprintf(buffer,"DMEM %d",desloc);
            desloc = retira_pr_fun(ts);
            desloc = retira_vs_pf(ts);
            geraCodigo(NULL,buffer);
            if (nivel_lexico > 0)
               nivel_lexico -= 1;
            mostra_ts(ts);
         }
;


parte_declara_rotulos: LABEL /*numero*/ VIRGULA /*numero*/
	    | /*numero*/
;

parte_declara_vars:  var
;


var         : { } VAR declara_vars
            |
;

declara_vars: declara_vars declara_var
            | declara_var
;

// Regra ajustada para declarar variáveis
declara_var : { num_vars = 0; }
              lista_id_var DOIS_PONTOS
              tipo
              { 
               char buffer[50];
               sprintf(buffer, "AMEM %d", num_vars);
               geraCodigo(NULL, buffer);
              }
              PONTO_E_VIRGULA
;

tipo        : IDENT
               {
                if (strcmp(token, "integer") == 0) {
                    atualiza_tipo(num_vars, INTEIRO, ts);
                } else if (strcmp(token, "boolean") == 0) {
                    atualiza_tipo(num_vars, BOOLEAN, ts);
                } else {
                    yyerror("ERRO: Tipo não reconhecido. Somente 'integer' ou 'boolean' são permitidos.");
                }
                mostra_ts(ts); // Mostra a tabela após a inserção
               }
;

lista_id_var: lista_id_var VIRGULA IDENT
              { /* insere �ltima vars na tabela de s�mbolos */ 
               num_vars += 1;
               info_t info;
               info.vs.tipo = NSEI;
               info.vs.desloc = desloc;
               insere_ts(token,VS,nivel_lexico,info,ts);
               desloc += 1;
              }
            | IDENT { 
               num_vars += 1;
               info_t info;
               info.vs.tipo = NSEI;
               info.vs.desloc = desloc;
               insere_ts(token,VS,nivel_lexico,info,ts);
               desloc += 1;
               /* insere vars na tabela de s�mbolos */
            }
;

lista_idents: lista_idents VIRGULA IDENT
            | IDENT
;

// REGRA 11
parte_declara_subrotinas: parte_declara_subrotinas
            declaracao_procedimento 
            | declaracao_funcao
            |
;

// REGRA 12
// Regra ajustada para declaração de procedimento
declaracao_procedimento: PROCEDURE IDENT {
               // Insere o procedimento na tabela de símbolos
               info_t info;
               char r_proc[4];
               sprintf(r_proc, "R%02d", rot_id);
               rot_id += 1;
               strcpy(info.pr.rot,r_proc);
               info.pr.quant = 0;
               info.pr.param = NULL;

               // Incrementa o nível léxico
               nivel_lexico += 1;
               desloc = 0; // Reinicia deslocamento para variáveis locais do novo nível

               insere_ts(token, PR, nivel_lexico, info, ts);
               empilha(token,proc);

               char buffer[50];
               sprintf(buffer,"ENPR %d",nivel_lexico);
               geraCodigo(r_proc,buffer);
               mostra_ts(ts);
            }
            parametros_ou_nada
            PONTO_E_VIRGULA bloco
            {
               char buffer[50];
               desempilha(buffer,proc);
               l_elem = busca(buffer,ts);
               sprintf(buffer,"RTPR %d, %d",l_elem->nivel,l_elem->info.pr.quant);
               geraCodigo(NULL,buffer);
               desloc = retira_vs_pf(ts);
               mostra_ts(ts);
            }
            PONTO_E_VIRGULA
;

// REGRA 13
// Regra ajustada para declaração de procedimento
declaracao_funcao: FUNCTION IDENT {
             // Insere o funcao na tabela de símbolos
            info_t info;
            char r_func[4];
            sprintf(r_func, "R%02d", rot_id);
            rot_id += 1;
            strcpy(info.fun.rot,r_func);
            info.fun.quant = 0;
            info.fun.param = NULL;
            info.fun.tipo = NSEI;

            // Incrementa o nível léxico
            nivel_lexico += 1;
            desloc = 0; // Reinicia deslocamento para variáveis locais do novo nível

            insere_ts(token, FUN, nivel_lexico, info, ts);
            empilha(token,proc);

            char buffer[50];
            sprintf(buffer,"ENPR %d",nivel_lexico);
            geraCodigo(r_func,buffer);
            mostra_ts(ts);
            }
            parametros_ou_nada
            DOIS_PONTOS {
               num_vars = 1;
            } tipo
            PONTO_E_VIRGULA bloco
            { 
               char buffer[50];
               desempilha(buffer,proc);
               l_elem = busca(buffer,ts);
               sprintf(buffer,"RTPR %d, %d",l_elem->nivel,l_elem->info.fun.quant);
               geraCodigo(NULL,buffer);
               desloc = retira_vs_pf(ts);
               mostra_ts(ts); 
            }
            PONTO_E_VIRGULA
;

parametros_ou_nada: ABRE_PARENTESES
            {num_param = 0;}
            paramentros_formais {
               char proc_ident[50];
               desempilha(proc_ident,proc);
               adiciona_param(proc_ident,num_param,ts);
               empilha(proc_ident,proc);
               mostra_ts(ts);
            }
             FECHA_PARENTESES
            |
;

paramentros_formais: secao_pfs
            | paramentros_formais PONTO_E_VIRGULA secao_pfs
;

secao_pfs: VAR 
            {
               num_vars = 0; 
               val_ou_ref = REF;
            }
            lista_id_pf DOIS_PONTOS tipo
            { 
               num_param += num_vars;
               val_ou_ref = VLR;
            }
            |  {
               num_vars = 0;
               val_ou_ref = VLR;
            }
            lista_id_pf DOIS_PONTOS tipo
            {num_param += num_vars;}
;

lista_id_pf: parametro VIRGULA lista_id_pf
            | parametro;
;

parametro: IDENT {
               num_vars += 1;
               info_t info;
               info.pf.tipo = NSEI;
               info.pf.desloc = NSEI;
               info.pf.passagem = val_ou_ref;
               insere_ts(token,PF,nivel_lexico,info,ts);
            }
;

comando_composto: T_BEGIN comandos T_END
;

comandos: comando PONTO_E_VIRGULA comandos
            | comando PONTO_E_VIRGULA
            |
;

comando: numero DOIS_PONTOS comando_sem_rotulo
            | comando_sem_rotulo
;

comando_sem_rotulo: atribuicao_ou_procedimento
            | comando_composto
            | comando_condicional
            | comando_repetitivo
            | leitura
            | escrita
;

atribuicao_ou_procedimento: IDENT {l_elem = busca(token, ts);}
            atribuicao_ou_procedimento_token
;

atribuicao_ou_procedimento_token: atribuicao
            | chamada_procedimento
;

atribuicao: {
    if (l_elem == NULL) {
        yyerror("ERRO: Variável de destino não declarada");
    } else {
         if (l_elem->categ == PF && l_elem->info.pf.passagem == REF)
            atr_indireto = REF;
         else atr_indireto = VLR; 
         destino_nivel = l_elem->nivel;
         if(l_elem->categ == VS)
            destino_desloc = l_elem->info.vs.desloc;
         else if(l_elem->categ == PF)
            destino_desloc = l_elem->info.pf.desloc;
         else if(l_elem->categ == FUN)
            destino_desloc = l_elem->info.fun.desloc;
         else
            yyerror("ERRO: Tentativa de atribuir em procedimento");

    }
} ATRIBUICAO expressao_simples {
    // Gera código ARMZ para armazenar valor
    char buffer[50];
    if (atr_indireto == REF) {
      sprintf(buffer, "ARMI %d, %d", destino_nivel, destino_desloc);
    } else {
      sprintf(buffer, "ARMZ %d, %d", destino_nivel, destino_desloc);
    }
    geraCodigo(NULL, buffer);
};


chamada_procedimento: 
            {
               if (l_elem == NULL){
                  yyerror("ERRO: Procedimento não declarado");
               } else{
                  // Gera código para chamar o procedimento
                  empilha(l_elem->ident, proc);
               }
               if (l_elem->categ == FUN)
                  geraCodigo(NULL, "AMEM 1");
               if (l_elem->categ == PR || l_elem->categ == FUN)
                  num_param = 0; // Reinicia a contagem de parâmetros reais   
            }

            lista_parametros
            
            { 
               char buffer[50];
               mostra_ts(ts);
               desempilha(buffer, proc);
               l_elem = busca(buffer, ts);

               if (l_elem->categ == PR || l_elem->categ ==FUN) {
                  // Verifica se o número de parâmetros reais bate com os formais
                  char error_msg[100];
                  if (l_elem->categ == PR && num_param != l_elem->info.pr.quant) {
                     sprintf(error_msg, "ERRO: número de parâmetros incorreto. Esperado: %d, recebido: %d.",
                              l_elem->info.pr.quant, num_param);
                     yyerror(error_msg);
                  } else if(l_elem->categ == FUN && num_param != l_elem->info.fun.quant){
                     sprintf(error_msg, "ERRO: número de parâmetros incorreto. Esperado: %d, recebido: %d.",
                              l_elem->info.fun.quant, num_param);
                     yyerror(error_msg);
                  }

                  // Gera o código de chamada do procedimento
                  
                  sprintf(buffer, "CHPR %s, %d", l_elem->info.pr.rot, nivel_lexico);
                  geraCodigo(NULL, buffer);
               }
            }
;

lista_parametros: ABRE_PARENTESES
               lista_parametros_parenteses
               FECHA_PARENTESES
               |
;

lista_parametros_parenteses: lista_parametros_parenteses VIRGULA 
               {
                  char buffer[50];
                  desempilha(buffer,proc);
                  l_elem = busca(buffer,ts);
                  val_ou_ref = l_elem->info.pr.param[num_param][1];
                  empilha(buffer,proc);
               }
               expressao_simples
               {
                  num_param++; // Incrementa para cada parâmetro real
                  val_ou_ref = VLR;
               }
               | {
                  char buffer[50];
                  desempilha(buffer,proc);
                  l_elem = busca(buffer,ts);
                  val_ou_ref = l_elem->info.pr.param[num_param][1];
                  empilha(buffer,proc);
               } 
               expressao_simples
               {
                  num_param++; // Conta o primeiro parâmetro real
                  val_ou_ref = VLR;
               }
;

leitura: READ ABRE_PARENTESES lista_leituras FECHA_PARENTESES
;

lista_leituras: lista_leituras VIRGULA simb_leitura
            | simb_leitura
;

simb_leitura: IDENT {
               geraCodigo(NULL, "LEIT");
               l_elem = busca(token,ts);
               char buffer[50];
               sprintf(buffer,"ARMZ %d, %d",l_elem->nivel,l_elem->info.vs.desloc);
               geraCodigo(NULL,buffer);
            }
;

escrita: WRITE ABRE_PARENTESES lista_escritas FECHA_PARENTESES
;

lista_escritas: lista_escritas VIRGULA expressao_simples {
               geraCodigo(NULL,"IMPR");
            }
            | expressao_simples {
               geraCodigo(NULL,"IMPR");
            }
;

expressao: expressao_simples IGUAL expressao_simples {
            geraCodigo(NULL, "CMIG"); // Adiciona operação de cmig
         }
         | expressao_simples DIFERENTE expressao_simples{
            geraCodigo(NULL, "CMDG"); // Adiciona operação de cmdg
         }
         | expressao_simples MENOR expressao_simples {
            geraCodigo(NULL, "CMME"); // Adiciona operação de cmme
         }
         | expressao_simples MENOR_IGUAL expressao_simples {
            geraCodigo(NULL, "CMEG"); // Adiciona operação de cmeg
         }
         | expressao_simples MAIOR expressao_simples {
            geraCodigo(NULL, "CMMA"); // Adiciona operação de cmma
         }
         | expressao_simples MAIOR_IGUAL expressao_simples {
            geraCodigo(NULL, "CMAG"); // Adiciona operação de cmag
         }
;

expressao_simples: expressao_simples MAIS termo {
               if (val_ou_ref == REF)
                  yyerror("ERRO: tentativa de EXPRESSAO em passagem por REFERENCIA\n");
               else
                  geraCodigo(NULL, "SOMA"); // Adiciona operação de soma
            }
            | expressao_simples MENOS termo {
               if (val_ou_ref == REF)
                  yyerror("ERRO: tentativa de EXPRESSAO em passagem por REFERENCIA\n");
               else
                  geraCodigo(NULL, "SUBT"); // Adiciona operação de subt
            }
            | termo
;

termo: termo ASTERISCO fator {
               geraCodigo(NULL, "MULT"); // Adiciona operação de mult
            }
            | termo DIV fator {
               geraCodigo(NULL, "DIVI"); // Adiciona operação de divi
            }
            | fator
;

fator: IDENT {
    // Carrega variável
    l_elem = busca(token, ts);
    empilha(token, proc);
   }
   chamada_procedimento 
   {
      char buffer[50];
      desempilha(buffer, proc);
      l_elem = busca(buffer, ts);
      if (l_elem == NULL) {
         yyerror("ERRO: Variável não declarada");
      } else {
         if (val_ou_ref == REF) {
               if (l_elem->categ == VS){
                  sprintf(buffer, "CREN %d, %d", l_elem->nivel, l_elem->info.vs.desloc);
                  geraCodigo(NULL, buffer);
               }
               else if (l_elem->categ == PF){
                  if(l_elem->info.pf.passagem == VLR)
                     sprintf(buffer, "CREN %d, %d", l_elem->nivel, l_elem->info.pf.desloc);
                  else
                     sprintf(buffer, "CRVL %d, %d", l_elem->nivel, l_elem->info.pf.desloc);
                  geraCodigo(NULL, buffer);
               }
               else
                  yyerror("ERRO: Tentativa de passagem de referencia de procedimento ou funcao");
               
         } 
         else if (l_elem->categ == PF && l_elem->info.pf.passagem == REF) {
               sprintf(buffer, "CRVI %d, %d", l_elem->nivel, l_elem->info.pf.desloc);
               geraCodigo(NULL, buffer);
         }        
         else {
               if (l_elem->categ == VS) {
                  sprintf(buffer, "CRVL %d, %d", l_elem->nivel, l_elem->info.vs.desloc);
                  geraCodigo(NULL, buffer);
               }
               else if (l_elem->categ == PF){
                  sprintf(buffer, "CRVL %d, %d", l_elem->nivel, l_elem->info.pf.desloc);
                  geraCodigo(NULL, buffer);
               }
         }
      }
   }
| NUMERO {
    // Empilha constante
    char buffer[50];
    if (val_ou_ref == VLR)
      sprintf(buffer, "CRCT %s", token);
    else {
      yyerror("ERRO: passagem de constante por REFERENCIA.\n");
    }
    geraCodigo(NULL, buffer);
}
| ABRE_PARENTESES expressao FECHA_PARENTESES
| ABRE_PARENTESES expressao_simples FECHA_PARENTESES
;

numero: NUMERO;

comando_repetitivo: {
               char r_ini[4];
               sprintf(r_ini, "R%02d", rot_id);
               empilha(r_ini, rot);
               rot_id += 1;
               geraCodigo(r_ini,"NADA");
            }
            WHILE expressao DO {
               char r_fim[4];
               sprintf(r_fim, "R%02d", rot_id);
               empilha(r_fim, rot);
               rot_id += 1;
               char buffer[50];
               strcpy(buffer, "DSVF ");
               strcat(buffer,r_fim);
               geraCodigo(NULL,buffer);
            }
            comando_sem_rotulo {
               char r_ini[4];
               char r_fim[4];

               desempilha(r_fim,rot);
               desempilha(r_ini,rot);

               char buffer[50];
               strcpy(buffer,"DSVS ");
               strcat(buffer,r_ini);
               geraCodigo(NULL,buffer);

               geraCodigo(r_fim,"NADA");
            }
;

comando_condicional: if_then cond_else {
               char r_fim[4];
               desempilha(r_fim,rot);
               geraCodigo(r_fim,"NADA");
            }
;

cond_else: ELSE
            comando_sem_rotulo
            | %prec LOWER_THAN_ELSE
;

if_then: IF expressao {
               char r_else[4];
               sprintf(r_else,"R%02d",rot_id);
               empilha(r_else,rot);
               rot_id += 1;
               char buffer[50];
               strcpy(buffer, "DSVF ");
               strcat(buffer,r_else);
               geraCodigo(NULL,buffer);
               
               char r_fim[4];
               sprintf(r_fim, "R%02d", rot_id);
               empilha(r_fim, rot);
               rot_id += 1;
            }
            THEN comando_sem_rotulo {
               char r_fim[4];
               desempilha(r_fim,rot);
               char r_else[4];
               desempilha(r_else,rot);
               
               empilha(r_fim,rot);
               char buffer[50];
               strcpy(buffer, "DSVS ");
               strcat(buffer,r_fim);
               geraCodigo(NULL,buffer);

               geraCodigo(r_else,"NADA");
            }
;


%%

int main (int argc, char** argv) {
   FILE* fp;
   extern FILE* yyin;

   if (argc<2 || argc>2) {
         printf("usage compilador <arq>a %d\n", argc);
         return(-1);
      }

   fp=fopen (argv[1], "r");
   if (fp == NULL) {
      printf("usage compilador <arq>b\n");
      return(-1);
   }


/* -------------------------------------------------------------------
 *  Inicia a Tabela de S�mbolos
 * ------------------------------------------------------------------- */
   ts = (ts_t *)malloc(sizeof(ts_t));
   inicializa_ts(ts);
   nivel_lexico = 0;
   desloc = 0;

   // Inicializa Rotulos
   rot = (custom_stack_t *)malloc(sizeof(custom_stack_t));
   inicializa_stack(rot);
   rot_id = 0;

   proc = (custom_stack_t *)malloc(sizeof(custom_stack_t));
   inicializa_stack(proc);

   yyin=fp;
   yyparse();

   return 0;
}
