#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "stack.h" 

void inicializa_stack(custom_stack_t *stack) {
    stack->topo = NULL;
    stack->tam = 0;
}

void empilha(char *item, custom_stack_t *stack) {
    if (stack == NULL) {
        return;
    }

    item_t *new = (item_t *)malloc(sizeof(item_t));
    new->item = (char *)malloc((strlen(item) + 1) * sizeof(char));
    strcpy(new->item, item);

    new->prox = stack->topo;
    stack->topo = new;
    stack->tam += 1;
}

void desempilha(char *item, custom_stack_t *stack) {
    if (stack == NULL || stack->topo == NULL) {
        return;
    }

    item_t *p = stack->topo;
    stack->topo = p->prox;
    stack->tam -= 1;

    strcpy(item, p->item);
    free(p->item);
    free(p);
}

void mostra_stack(custom_stack_t *stack) {
    if (stack == NULL || stack->topo == NULL) {
        printf("Pilha está vazia ou não inicializada.\n");
        return;
    }

    printf("\nPilha:\n");
    printf("----------------------------------------------------------------------------------\n");
    printf("| %-10s |\n", "Item");
    printf("----------------------------------------------------------------------------------\n");

    item_t *p = stack->topo;
    while (p != NULL) {
        printf("| %-10s |\n", p->item);
        p = p->prox;
    }
    printf("----------------------------------------------------------------------------------\n");
}